package dev.shadowsoffire.apotheosis.adventure.socket.gem.cutting;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import dev.shadowsoffire.apotheosis.advancements.AdvancementTriggers;
import dev.shadowsoffire.apotheosis.adventure.Adventure;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixHelper;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.apotheosis.adventure.loot.RarityRegistry;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.GemInstance;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.GemItem;
import dev.shadowsoffire.placebo.cap.InternalItemHandler;
import dev.shadowsoffire.placebo.menu.PlaceboContainerMenu;
import dev.shadowsoffire.placebo.reload.DynamicHolder;
import java.util.ArrayList;
import java.util.List;
import net.minecraft.core.BlockPos;
import net.minecraft.server.level.ServerPlayer;
import net.minecraft.sounds.SoundEvents;
import net.minecraft.sounds.SoundSource;
import net.minecraft.world.Container;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.inventory.ContainerLevelAccess;
import net.minecraft.world.inventory.MenuType;
import net.minecraft.world.inventory.Slot;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.Level;
import net.minecraftforge.items.IItemHandlerModifiable;
import net.minecraftforge.items.wrapper.RecipeWrapper;

public class GemCuttingMenu extends PlaceboContainerMenu {
  public static final int NEXT_MAT_COST = 1;
  
  public static final int STD_MAT_COST = 3;
  
  public static final int PREV_MAT_COST = 9;
  
  public static final List<GemCuttingRecipe> RECIPES = new ArrayList<>();
  
  protected final Player player;
  
  protected final ContainerLevelAccess access;
  
  static {
    RECIPES.add(new RarityUpgrade());
  }
  
  protected final InternalItemHandler inv = (InternalItemHandler)new Object(this, 4);
  
  public GemCuttingMenu(int id, Inventory playerInv) {
    this(id, playerInv, ContainerLevelAccess.f_39287_);
  }
  
  public GemCuttingMenu(int id, Inventory playerInv, ContainerLevelAccess access) {
    super((MenuType)Adventure.Menus.GEM_CUTTING.get(), id, playerInv);
    this.player = playerInv.f_35978_;
    this.access = access;
    m_38897_((Slot)new PlaceboContainerMenu.UpdatingSlot(this, this.inv, 0, 62, 45, stack -> GemItem.getGem(stack).isBound()));
    m_38897_((Slot)new PlaceboContainerMenu.UpdatingSlot(this, this.inv, 1, 90, 64, stack -> (stack.m_41720_() == Adventure.Items.GEM_DUST.get())));
    m_38897_((Slot)new PlaceboContainerMenu.UpdatingSlot(this, this.inv, 2, 33, 64, this::matchesMainGem));
    m_38897_((Slot)new PlaceboContainerMenu.UpdatingSlot(this, this.inv, 3, 62, 12, this::isValidMaterial));
    addPlayerSlots(playerInv, 8, 98);
    this.mover.registerRule((stack, slot) -> (slot.intValue() >= this.playerInvStart && this.inv.getStackInSlot(0).m_41619_() && isValidMainGem(stack)), 0, 1);
    this.mover.registerRule((stack, slot) -> (slot.intValue() >= this.playerInvStart && stack.m_41720_() == Adventure.Items.GEM_DUST.get()), 1, 2);
    this.mover.registerRule((stack, slot) -> (slot.intValue() >= this.playerInvStart && matchesMainGem(stack)), 2, 3);
    this.mover.registerRule((stack, slot) -> (slot.intValue() >= this.playerInvStart && isValidMaterial(stack)), 3, 4);
    this.mover.registerRule((stack, slot) -> (slot.intValue() < this.playerInvStart), this.playerInvStart, this.hotbarStart + 9);
    registerInvShuffleRules();
  }
  
  public boolean m_6366_(Player player, int id) {
    if (id == 0) {
      ItemStack gem = this.inv.getStackInSlot(0);
      ItemStack left = this.inv.getStackInSlot(1);
      ItemStack bot = this.inv.getStackInSlot(2);
      ItemStack right = this.inv.getStackInSlot(3);
      for (GemCuttingRecipe r : RECIPES) {
        if (r.matches(gem, left, bot, right)) {
          ItemStack out = r.getResult(gem, left, bot, right);
          r.decrementInputs(gem, left, bot, right);
          this.inv.setStackInSlot(0, out);
          this.level.m_5594_(player, player.m_20183_(), SoundEvents.f_144242_, SoundSource.BLOCKS, 1.0F, 1.5F + 0.35F * (1.0F - 2.0F * this.level.f_46441_.m_188501_()));
          AdvancementTriggers.GEM_CUT.trigger((ServerPlayer)player, out, AffixHelper.getRarity(out).getId());
          return true;
        } 
      } 
    } 
    return false;
  }
  
  public static boolean isValidMainGem(ItemStack stack) {
    GemInstance inst = GemInstance.unsocketed(stack);
    return (inst.isValidUnsocketed() && !inst.isMaxRarity());
  }
  
  protected boolean isValidMaterial(ItemStack stack) {
    GemInstance mainGem = GemInstance.unsocketed(this.inv.getStackInSlot(0));
    if (!mainGem.isValidUnsocketed())
      return false; 
    DynamicHolder<LootRarity> rarity = RarityRegistry.getMaterialRarity(stack.m_41720_());
    return (rarity.isBound() && Math.abs(((LootRarity)rarity.get()).ordinal() - ((LootRarity)mainGem.rarity().get()).ordinal()) <= 1);
  }
  
  protected boolean matchesMainGem(ItemStack stack) {
    GemInstance gem = GemInstance.unsocketed(stack);
    GemInstance mainGem = GemInstance.unsocketed(this.inv.getStackInSlot(0));
    return (gem.isValidUnsocketed() && mainGem.isValidUnsocketed() && gem.gem() == mainGem.gem() && gem.rarity() == mainGem.rarity());
  }
  
  public boolean m_6875_(Player pPlayer) {
    return ((Boolean)this.access.m_39299_((level, pos) -> Boolean.valueOf((level.m_8055_(pos).m_60734_() == Adventure.Blocks.GEM_CUTTING_TABLE.get())), Boolean.valueOf(true))).booleanValue();
  }
  
  public void m_6877_(Player pPlayer) {
    super.m_6877_(pPlayer);
    this.access.m_39292_((level, pos) -> m_150411_(pPlayer, (Container)new RecipeWrapper((IItemHandlerModifiable)this.inv)));
  }
  
  public static int getDustCost(LootRarity gemRarity) {
    return 1 + gemRarity.ordinal() * 2;
  }
}
